#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gccore.h>
#include <malloc.h>

#include "IOSPatcher.h"
#include "iospatch.h"
#include "wad.h"
#include "tools.h"
#include "network.h"
#include "uninstall.h"

#define IOS36version 3864

// Prevent IOS36 loading at startup
/*s32 __IOS_LoadStartupIOS()
{
	return 0;
}*/

s32 __u8Cmp(const void *a, const void *b)
{
	return *(u8 *)a-*(u8 *)b;
}

void __AHBPROT_FatalError(void) {
		printf("\nFATAL ERROR:\n");
		printf("Unable to initialise the initial patches.\n");
		printf("This either means you didn't follow the download\n");
		printf("and launching instructions correctly, or your IOS\n");
		printf("is not vulnerable for an unknown reason.\n");
		printf("Perhaps you need to update the Homebrew Channel (HBC).\n");
		printf("Installation cannot continue.  Press any button to exit...\n");
		waitforbuttonpress(NULL, NULL);
		Reboot();
}

int main(int argc, char* argv[])
{
	int ret;	

	/* Enable AHBPROT on title launch */
	ret = IOSPATCH_AHBPROT();
	if (ret) {
		/* Reload current IOS */
		IOS_ReloadIOS(IOS_GetVersion());
	}

	Init_Console();
	printf("\x1b[%u;%um", 37, false);

	PAD_Init();
	WPAD_Init();
	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC_IR);					

	printheadline();

	/* Fatal error */
	if (!ret) {
		__AHBPROT_FatalError();
  }
	printf("\nThanks, in no particular order, go to Wiipower, oggzee, Team Twiizers,\n");
	printf("tona, Joseph Jordan and anybody else who has code included in the app.\n");
	printf("The app was quite a simple job, built upon their actual real work.\n");
	printf("App made by Dr Clipper/Davebaol, then automated by ZRicky11.\n");
	printf("Wii U's vWii IOS support added by damysteryman.\n\n");
	printf("This MOD version of IOS236 installer is for Wii U's vWii ONLY!\nUsing this in a regular Wii will result in a broken IOS236.\n");
	printf("REQUIRES vWii IOS36 v3864 wad located at SD:/IOS36-64-v3864.wad!\n(It is not avaible on NUS, must dump from a vWii or acquire elsewhere)\n\n");
	/*printf("\nPlease Wait...\n");
	
	time_t t = time(NULL) + 7;
	while (time(NULL) < t)
	{
		WPAD_ScanPads();
		PAD_ScanPads();
		if(WPAD_ButtonsDown(0) || PAD_ButtonsDown(0)) 
		{
			printf("Don't be impatient, press any button to exit...\n");
			waitforbuttonpress(NULL, NULL);
			Reboot();
		}
	}*/
	printf("Press any button to continue...\n");
	waitforbuttonpress(NULL, NULL);
	
	printf("Patching IOS\n");
	if (!IOSPATCH_Apply()) {
		__AHBPROT_FatalError();
  }
	printf("IOS patched\n");
	printf("About to install IOS236\n");

	ret = Install_patched_IOS(36, IOS36version, true, true, true, true, true, 236, 65535, false);
	if (ret < 0) {
		printf("IOS236 Install failed.  Press any button to exit...\n");
		waitforbuttonpress(NULL, NULL);
		Reboot();
	}


	printf("\nIOS236 Installation is complete!\nPress any button to exit.");
	waitforbuttonpress(NULL, NULL);
	
	Reboot();

	return 0;
}